sdr::AMDemod< Scalar > Class Template Reference
Demodulator nodes.

Amplitude modulation (AM) demodulator from an I/Q signal. More...

`#include <demod.hh>`

Inheritance diagram for sdr::AMDemod< Scalar >:

## Public Member Functions

| AMDemod ()
| Constructor. More...
virtual | ~AMDemod ()
| Destructor. More...
virtual void | config (const Config &src_cfg)
| Configures the AM demod. More...
virtual void | process (const Buffer< std::complex< Scalar > > &buffer, bool allow_overwrite)
| Handles the I/Q input buffer. More...
Public Member Functions inherited from sdr::Sink< std::complex< Scalar > >
| Sink ()
| Constructor. More...
virtual | ~Sink ()
| Drestructor. More...
virtual void | handleBuffer (const RawBuffer &buffer, bool allow_overwrite)
| Re-implemented from `SinkBase`. More...
Public Member Functions inherited from sdr::SinkBase
| SinkBase ()
| Constructor. More...
virtual | ~SinkBase ()
| Destructor. More...
Public Member Functions inherited from sdr::Source
| Source ()
| Constructor. More...
virtual | ~Source ()
| Destructor. More...
virtual void | send (const RawBuffer &buffer, bool allow_overwrite=false)
| Sends the given buffer to all connected sinks. More...
void | connect (SinkBase *sink, bool direct=false)
| Connect this source to a sink. More...
void | disconnect (SinkBase *sink)
| Disconnect a sink again. More...
virtual void | setConfig (const Config &config)
| Stores the configuration and propergates it if the configuration has been changed. More...
virtual double | sampleRate () const
| Returns the configured sample rate or `0` otherwise. More...
virtual Config::Type | type () const
| Returns the configured source type or `Config::Type_UNDEFINED` otherwise. More...
template<class T >
void | addEOS (T *instance, void(T::*function)())
| Adds a callback to the end-of-stream signal of the source. More...

## Protected Attributes

Buffer< Scalar > | _buffer
| The output buffer. More...
Protected Attributes inherited from sdr::Source
Config | _config
| Holds the source configuration, this can be updated by calling `setConfig`. More...
std::map< SinkBase *, bool > | _sinks
| The connected sinks. More...
std::list< DelegateInterface * > | _eos
| The connected EOS singal handlers. More...

## Additional Inherited Members

Protected Member Functions inherited from sdr::Source
void | signalEOS ()
| Signals the EOS. More...
void | propagateConfig (const Config &config)
| Propagates the given configuration to all connected sinks. More...

## Detailed Description

### template<class Scalar>
class sdr::AMDemod< Scalar >

Amplitude modulation (AM) demodulator from an I/Q signal.

## Constructor & Destructor Documentation

template<class Scalar >

sdr::AMDemod< Scalar >::AMDemod | ( |  | ) |

inline

Constructor.

template<class Scalar >

virtual sdr::AMDemod< Scalar >::~AMDemod | ( |  | ) |

inlinevirtual

Destructor.

## Member Function Documentation

template<class Scalar >

virtual void sdr::AMDemod< Scalar >::config | ( | const Config & | src_cfg | ) |

inlinevirtual

Configures the AM demod.

Implements sdr::SinkBase.

template<class Scalar >

virtual void sdr::AMDemod< Scalar >::process | ( | const Buffer< std::complex< Scalar > > & | buffer,
|  | bool | allow_overwrite
| ) |  |

inlinevirtual

Handles the I/Q input buffer.

Implements sdr::Sink< std::complex< Scalar > >.

## Member Data Documentation

template<class Scalar >

Buffer<Scalar> sdr::AMDemod< Scalar >::_buffer

protected

The output buffer.

The documentation for this class was generated from the following file:

- /Users/hannes/Uni/Elektronik/sdr/libsdr/src/demod.hh